﻿<?xml version="1.0" encoding="UTF-8"?>
<ContentPage xmlns="http://xamarin.com/schemas/2014/forms"
             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
             xmlns:me="clr-namespace:TestXam.Models;assembly=TestXam"
             xmlns:ctrls="clr-namespace:TestXam.Converters;assembly=TestXam"
             x:Class="TestXam.Views.PersonDetails"
             xmlns:ltriggers="clr-namespace:TestXam.Triggers;assembly=TestXam">

    <!--
    <ContentPage.BindingContext>
        <me:Person Name="AVODAGBE" LastName="Godwin" Email="t@t.fr"></me:Person>
    </ContentPage.BindingContext>
    -->
   <ContentPage.Resources>
        <ResourceDictionary>
            <ctrls:EmailConverter x:Key="emailConverter"></ctrls:EmailConverter>
            <ctrls:BoolStringLengthConverter x:Key="boolStringLengthConverter"></ctrls:BoolStringLengthConverter>
            <ctrls:StringLengthColorConverter x:Key="stringLengthColorConverter"></ctrls:StringLengthColorConverter>
            <me:Person Name="M2i" Email="t@t.fr" LastName="Godwin" x:Key="p1" ></me:Person>
        </ResourceDictionary>
    </ContentPage.Resources>
    <ContentPage.Content>
        <Grid VerticalOptions="FillAndExpand"
                HorizontalOptions="FillAndExpand"
                BackgroundColor="Gray">

            <Grid.RowDefinitions>
                <RowDefinition Height="*"/>
                <RowDefinition Height="*"/>
                <RowDefinition Height="*"/>
                <RowDefinition Height="*"/>
                <RowDefinition Height="4*"/>
                <RowDefinition Height="*"/>
            </Grid.RowDefinitions>

            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="*"/>
                <ColumnDefinition Width="3*"/>
            </Grid.ColumnDefinitions>

            
            <Label Grid.Row="0" Grid.Column="0" Text="Nom"></Label>
            <Entry Grid.Row="0" Grid.Column="1" Text="{Binding CurrentUser.Name}" x:Name="Nom"
                   TextChanged="NomTextChanged">

            </Entry>

            <Label Grid.Row="1" Grid.Column="0" Text="Prénom"></Label>
            <Entry Grid.Row="1" Grid.Column="1" Text="{Binding CurrentUser.LastName}">
                <Entry.Triggers>
                    <Trigger TargetType="Entry" Property="IsFocused" Value="True">
                        <Setter Property="FontAttributes" Value="Bold"></Setter>
                    </Trigger>
                    <EventTrigger Event="TextChanged">
                        <ltriggers:RequiredValidationTriggerAction></ltriggers:RequiredValidationTriggerAction>
                    </EventTrigger>
                </Entry.Triggers>
            </Entry>
            
            <!--<Slider x:Name="slowSlider" Minimum="0" Maximum="360"
                    Grid.Row="3" Grid.Column="0" Grid.ColumnSpan="2"></Slider>

            <Label Text="Nous sommes en formation" Rotation="{Binding Source={x:Reference slowSlider}, Path=Value}"
                    Grid.Row="4" Grid.Column="0" Grid.ColumnSpan="2" ></Label>

            <Switch IsToggled="{Binding IsEnabled, Mode=OneWayToSource}" BindingContext="{ x:Reference Nom}"
                    Grid.Row="5" Grid.Column="0" Grid.ColumnSpan="2" ></Switch>

            <Label Grid.Row="6" Grid.Column="0" Text="Email"></Label>
            <Entry Grid.Row="6" Grid.Column="1" Text="{Binding CurrentUser.Email}"
                    TextColor="{Binding CurrentUser.Email, Converter={StaticResource stringLengthColorConverter}}"></Entry>

            <Label Text="Le texte de votre email est trop long"
                    Grid.Row="7" Grid.Column="0" Grid.ColumnSpan="2"
                    TextColor="{Binding CurrentUser.Email, Converter={StaticResource stringLengthColorConverter}}"
                    IsVisible="{Binding CurrentUser.Email, Converter={StaticResource boolStringLengthConverter}}"></Label>

            -->
            <Button Text="Enregistrer" Command="{Binding AddUserCommand}"
                    Grid.Row="2" Grid.Column="0" Grid.ColumnSpan="2" ></Button>

            <ListView ItemsSource="{Binding Users}"
                      Grid.Row="3"
                      Grid.RowSpan="2"
                      Grid.Column="0" Grid.ColumnSpan="2" HasUnevenRows="True">

                <ListView.ItemTemplate>
                    <DataTemplate>
                        <ViewCell>
                            <!--
                            <StackLayout VerticalOptions="FillAndExpand"
                                            HorizontalOptions="FillAndExpand">
                                <Label Text="{Binding Name}"></Label>
                                <Label Text="{Binding LastName}"></Label>
                                <Label Text="{Binding Email}"></Label>
                            </StackLayout>
                            -->
                            <Grid VerticalOptions="FillAndExpand"
                                  HorizontalOptions="FillAndExpand">
                                <Grid.RowDefinitions>
                                    <RowDefinition Height="auto"/>
                                    <RowDefinition Height="auto"/>
                                    <RowDefinition Height="auto"/>
                                </Grid.RowDefinitions>

                                <Grid.ColumnDefinitions>
                                    <ColumnDefinition Width="*"/>
                                    <ColumnDefinition Width="3*"/>
                                </Grid.ColumnDefinitions>

                                <Image  HorizontalOptions="Center"
                                        VerticalOptions="Center"
                                        Aspect="AspectFit"
                                        Source="monkey.jpg"
                                        Grid.Row="0"
                                        Grid.RowSpan="3"
                                        Grid.Column="0"
                                        HeightRequest="100"
                                        >
                                        
                                </Image>

                                <Label Text="{Binding Name}" Grid.Row="0" Grid.Column="1" FontSize="Small"></Label>
                                <Label Text="{Binding Username}" Grid.Row="1" Grid.Column="1" FontSize="Small"></Label>
                                <Label Text="{Binding Email}" Grid.Row="2" Grid.Column="1" FontSize="Small"></Label>
                            </Grid>
                        </ViewCell>
                    </DataTemplate>
                </ListView.ItemTemplate>
            </ListView>

            <!--
            <Editor Text="" >
                <Editor.Triggers>


                </Editor.Triggers>
            </Editor>
            <Label Grid.Row="1" Grid.Column="0" Text="Nom"></Label>
            <Entry Grid.Row="1" Grid.Column="1" Text="{Binding Name, Source={StaticResource p1}}" ></Entry>

            <Label Grid.Row="2" Grid.Column="0" Text="Prénom"></Label>
            <Entry Grid.Row="2" Grid.Column="1" Text="{Binding LastName, Source={StaticResource p1}}" ></Entry>
            -->
            
        </Grid>
    </ContentPage.Content>
</ContentPage>
